#ifndef OCARINA_SONGLIST_H
#define OCARINA_SONGLIST_H

#include <ocarina/gtk.h>
#include <libsaria/track.h>
#include <libsaria/model.h>

#include <list>
#include <string>
using namespace std;

class MenuItem
{
	private:
		string text;
		void (*func)(GtkMenuItem *, gpointer);

	public:
		MenuItem(string, void (*)(GtkMenuItem *, gpointer));
		~MenuItem();

		GtkWidget *get_widget();
};

/* Make this a class to inherit from? */
struct SongListFuncs
{
	unsigned int (*size)();
	void (*iter_reset)();
	libsaria::Track *(*iter_next)();
	bool (*iter_end)();
};

class SongList : public libsaria::SourceModel
{
	private:
		int ins_next;
		SongListFuncs *list_funcs;
		list <MenuItem> *menu_items;
		string name;

		GtkWidget *window;
		GtkWidget *label;

		GtkWidget *treeview;
		GtkListStore *liststore;
		GtkTreeModel *filter;
		GtkTreeSelection *selection;
		GtkCellRenderer *textcell;

		void set_label_text();
		void freeze();
		void thaw();

	public:
		SongList();
		~SongList();

		void init(string, SongListFuncs *, list<MenuItem> *, bool);
		GtkWidget *get_window();
		GtkWidget *get_label();

		void insert(libsaria::Track *);
		void fill();
		void clear();
		void refilter();
		void list_selected_ids(list<sid_t> &);
		void scroll_to(libsaria::Track *);

		gint right_click(guint, guint64);
};

#endif /* OCARINA_SONGLIST_H */
