
#include <libsaria/audio.h>
#include <libsaria/prefs.h>
#include "audio.h"

void configure_volume(float volume)
{
	GValue value = { 0, };
	g_value_init(&value, G_TYPE_DOUBLE);
	g_value_set_double(&value, volume);

	g_object_set_property(G_OBJECT(player), "volume", &value);
}

namespace libsaria
{

	void audio::set_volume(float volume)
	{
		prefs::set("volume", volume);
	}

	void audio::init_volume()
	{
		configure_volume(prefs::get_float("volume", 1.0));
	}

	float audio::get_volume()
	{
		return prefs::get_float("volume", 1.0);
	}

};
