
#include <list>
using namespace std;

#include <libsaria/queue.h>
#include <libsaria/library.h>
#include <libsaria/callback.h>
#include "queue.h"

list<sid_t> playqueue;

static void save_and_refresh()
{
	trigger_callback(QUEUE_REFRESH);
	libsaria::queue::save();
}

namespace libsaria
{

	void queue::add_ids(list<sid_t> &ids)
	{
		playqueue.insert(playqueue.end(), ids.begin(), ids.end());
		save_and_refresh();
	}

	void queue::rm_ids(list<sid_t> &ids)
	{
		list<sid_t>::iterator it;
		for (it = ids.begin(); it != ids.end(); it++)
			playqueue.remove(*it);
		save_and_refresh();
	}

	unsigned int queue::size()
	{
		return playqueue.size();
	}

	string queue::next_file()
	{
		sid_t inode = playqueue.front();
		playqueue.pop_front();
		save_and_refresh();
		return library::find_filepath(inode);
	}

} /* Namespace: libsaria */
