
#include <ocarina/songlist.h>
#include <libsaria/controls.h>
#include <libsaria/print.h>
#include "songlist.h"

#define BUTTON_RIGHT 3

MenuItem::MenuItem(string s, void (*f)(GtkMenuItem *, gpointer))
{
	text = s;
	func = f;
}

MenuItem::~MenuItem() {}

GtkWidget *MenuItem::get_widget()
{
	GtkWidget *widget = gtk_menu_item_new_with_label(text.c_str());
	GTK_CONNECT(widget, "activate", func, NULL);
	return widget;
}

static void toggle_pause_after(GtkMenuItem *menu, gpointer data)
{
	libsaria::set_pause_after(!libsaria::get_pause_after());
}

static GtkWidget *make_pause_after_item()
{
	GtkWidget *widget = gtk_check_menu_item_new_with_label("Pause After Current Song");
	gtk_check_menu_item_set_active(GTK_CHECK_MENU_ITEM(widget),
				       libsaria::get_pause_after());
	GTK_CONNECT(widget, "activate", toggle_pause_after, NULL);
	return widget;
}

gint SongList::right_click(guint button, guint64 time)
{
	list<MenuItem>::iterator it;
	GtkWidget *menu = gtk_menu_new();

	for (it = menu_items->begin(); it != menu_items->end(); it++)
		gtk_menu_append(GTK_MENU(menu), it->get_widget());

	gtk_menu_append(GTK_MENU(menu), make_pause_after_item());

	gtk_widget_show_all(menu);
	gtk_menu_popup(GTK_MENU(menu), NULL, NULL, NULL, NULL, button, time);
	return TRUE;
}

void songlist_button_click(GtkWidget *widget, GdkEvent *event, gpointer data)
{
	SongList *list = (SongList *)data;

	if (event->button.button != BUTTON_RIGHT)
		return;
	list->right_click(event->button.button, event->button.time);
}
